/* i-properties-provider.c generated by valac 0.18.0.79-04df6, the Vala compiler
 * generated from i-properties-provider.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <libcommon.h>
#include <osinfo/osinfo.h>
#include <float.h>
#include <math.h>


#define BOXES_TYPE_PROPERTY (boxes_property_get_type ())
#define BOXES_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_PROPERTY, BoxesProperty))
#define BOXES_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_PROPERTY, BoxesPropertyClass))
#define BOXES_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_PROPERTY))
#define BOXES_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_PROPERTY))
#define BOXES_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_PROPERTY, BoxesPropertyClass))

typedef struct _BoxesProperty BoxesProperty;
typedef struct _BoxesPropertyClass BoxesPropertyClass;
typedef struct _BoxesPropertyPrivate BoxesPropertyPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PROPERTY_CREATION_FLAG (property_creation_flag_get_type ())

#define BOXES_TYPE_IPROPERTIES_PROVIDER (boxes_iproperties_provider_get_type ())
#define BOXES_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProvider))
#define BOXES_IS_IPROPERTIES_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER))
#define BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BOXES_TYPE_IPROPERTIES_PROVIDER, BoxesIPropertiesProviderIface))

typedef struct _BoxesIPropertiesProvider BoxesIPropertiesProvider;
typedef struct _BoxesIPropertiesProviderIface BoxesIPropertiesProviderIface;

#define BOXES_TYPE_PROPERTIES_PAGE (boxes_properties_page_get_type ())

#define BOXES_TYPE_EDITABLE_ENTRY (boxes_editable_entry_get_type ())
#define BOXES_EDITABLE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntry))
#define BOXES_EDITABLE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntryClass))
#define BOXES_IS_EDITABLE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_EDITABLE_ENTRY))
#define BOXES_IS_EDITABLE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_EDITABLE_ENTRY))
#define BOXES_EDITABLE_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntryClass))

typedef struct _BoxesEditableEntry BoxesEditableEntry;
typedef struct _BoxesEditableEntryClass BoxesEditableEntryClass;
typedef struct _Block16Data Block16Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block17Data Block17Data;

struct _BoxesProperty {
	GObject parent_instance;
	BoxesPropertyPrivate * priv;
};

struct _BoxesPropertyClass {
	GObjectClass parent_class;
};

struct _BoxesPropertyPrivate {
	gchar* _description;
	GtkWidget* _widget;
	GtkWidget* _extra_widget;
	gboolean _reboot_required;
	guint _defer_interval;
	guint deferred_change_id;
	GSourceFunc _deferred_change;
	gpointer _deferred_change_target;
	GDestroyNotify _deferred_change_target_destroy_notify;
};

typedef void (*PropertyStringChanged) (BoxesProperty* property, const gchar* value, void* user_data, GError** error);
typedef void (*PropertySizeChanged) (BoxesProperty* property, guint64 value, void* user_data, GError** error);
typedef enum  {
	PROPERTY_CREATION_FLAG_NONE = 0,
	PROPERTY_CREATION_FLAG_NO_USB = 1 << 0
} PropertyCreationFlag;

typedef enum  {
	BOXES_PROPERTIES_PAGE_LOGIN,
	BOXES_PROPERTIES_PAGE_SYSTEM,
	BOXES_PROPERTIES_PAGE_DISPLAY,
	BOXES_PROPERTIES_PAGE_DEVICES,
	BOXES_PROPERTIES_PAGE_LAST
} BoxesPropertiesPage;

struct _BoxesIPropertiesProviderIface {
	GTypeInterface parent_iface;
	GList* (*get_properties) (BoxesIPropertiesProvider* self, BoxesPropertiesPage page, PropertyCreationFlag flags);
};

struct _Block16Data {
	int _ref_count_;
	BoxesIPropertiesProvider * self;
	BoxesEditableEntry* entry;
	BoxesProperty* property;
	PropertyStringChanged changed;
	gpointer changed_target;
};

struct _Block17Data {
	int _ref_count_;
	BoxesIPropertiesProvider * self;
	GtkLabel* label;
	GtkScale* scale;
	BoxesProperty* property;
	PropertySizeChanged changed;
	gpointer changed_target;
};


static gpointer boxes_property_parent_class = NULL;

GType boxes_property_get_type (void) G_GNUC_CONST;
#define BOXES_PROPERTY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BOXES_TYPE_PROPERTY, BoxesPropertyPrivate))
enum  {
	BOXES_PROPERTY_DUMMY_PROPERTY,
	BOXES_PROPERTY_DESCRIPTION,
	BOXES_PROPERTY_WIDGET,
	BOXES_PROPERTY_EXTRA_WIDGET,
	BOXES_PROPERTY_REBOOT_REQUIRED,
	BOXES_PROPERTY_DEFER_INTERVAL
};
BoxesProperty* boxes_property_new (const gchar* description, GtkWidget* widget, GtkWidget* extra_widget);
BoxesProperty* boxes_property_construct (GType object_type, const gchar* description, GtkWidget* widget, GtkWidget* extra_widget);
void boxes_property_flush (BoxesProperty* self);
GSourceFunc boxes_property_get_deferred_change (BoxesProperty* self, gpointer* result_target);
void boxes_property_set_deferred_change (BoxesProperty* self, GSourceFunc value, gpointer value_target, GDestroyNotify value_target_destroy_notify);
const gchar* boxes_property_get_description (BoxesProperty* self);
void boxes_property_set_description (BoxesProperty* self, const gchar* value);
GtkWidget* boxes_property_get_widget (BoxesProperty* self);
void boxes_property_set_widget (BoxesProperty* self, GtkWidget* value);
GtkWidget* boxes_property_get_extra_widget (BoxesProperty* self);
void boxes_property_set_extra_widget (BoxesProperty* self, GtkWidget* value);
gboolean boxes_property_get_reboot_required (BoxesProperty* self);
void boxes_property_set_reboot_required (BoxesProperty* self, gboolean value);
guint boxes_property_get_defer_interval (BoxesProperty* self);
void boxes_property_set_defer_interval (BoxesProperty* self, guint value);
static gboolean _boxes_property_deferred_change___lambda11_ (BoxesProperty* self);
static gboolean __boxes_property_deferred_change___lambda11__gsource_func (gpointer self);
static void boxes_property_finalize (GObject* obj);
static void _vala_boxes_property_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_boxes_property_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType property_creation_flag_get_type (void) G_GNUC_CONST;
GType boxes_properties_page_get_type (void) G_GNUC_CONST;
GType boxes_iproperties_provider_get_type (void) G_GNUC_CONST;
GList* boxes_iproperties_provider_get_properties (BoxesIPropertiesProvider* self, BoxesPropertiesPage page, PropertyCreationFlag flags);
BoxesProperty* boxes_iproperties_provider_add_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, GtkWidget* widget, GtkWidget* extra_widget);
BoxesProperty* boxes_iproperties_provider_add_string_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, const gchar* value, PropertyStringChanged changed, void* changed_target);
GType boxes_editable_entry_get_type (void) G_GNUC_CONST;
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
BoxesEditableEntry* boxes_editable_entry_new (void);
BoxesEditableEntry* boxes_editable_entry_construct (GType object_type);
void boxes_editable_entry_set_text (BoxesEditableEntry* self, const gchar* value);
void boxes_editable_entry_set_selectable (BoxesEditableEntry* self, gboolean value);
void boxes_editable_entry_set_editable (BoxesEditableEntry* self, gboolean value);
static void __lambda18_ (Block16Data* _data16_);
const gchar* boxes_editable_entry_get_text (BoxesEditableEntry* self);
void boxes_editable_entry_start_editing (BoxesEditableEntry* self);
static void ___lambda18__boxes_editable_entry_editing_done (BoxesEditableEntry* _sender, gpointer self);
BoxesProperty* boxes_iproperties_provider_add_size_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, guint64 size, guint64 min, guint64 max, guint64 step, PropertySizeChanged changed, void* changed_target);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void __lambda19_ (Block17Data* _data17_);
static void ___lambda19__gtk_range_value_changed (GtkRange* _sender, gpointer self);
static void ___lambda20_ (Block17Data* _data17_);
static void ____lambda20__gtk_range_value_changed (GtkRange* _sender, gpointer self);


BoxesProperty* boxes_property_construct (GType object_type, const gchar* description, GtkWidget* widget, GtkWidget* extra_widget) {
	BoxesProperty * self = NULL;
	const gchar* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
#line 39 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 40 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = description;
#line 40 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = widget;
#line 40 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = extra_widget;
#line 40 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = (BoxesProperty*) g_object_new (object_type, "description", _tmp0_, "widget", _tmp1_, "extra-widget", _tmp2_, NULL);
#line 39 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return self;
#line 193 "i-properties-provider.c"
}


BoxesProperty* boxes_property_new (const gchar* description, GtkWidget* widget, GtkWidget* extra_widget) {
#line 39 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return boxes_property_construct (BOXES_TYPE_PROPERTY, description, widget, extra_widget);
#line 200 "i-properties-provider.c"
}


void boxes_property_flush (BoxesProperty* self) {
	GSourceFunc _tmp0_;
	void* _tmp0__target;
	GSourceFunc _tmp1_;
	void* _tmp1__target;
	GSourceFunc _tmp2_;
	void* _tmp2__target;
	GSourceFunc _tmp3_;
	void* _tmp3__target;
#line 43 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = boxes_property_get_deferred_change (self, &_tmp0__target);
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = _tmp0_;
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1__target = _tmp0__target;
#line 44 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp1_ == NULL) {
#line 45 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 225 "i-properties-provider.c"
	}
#line 47 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = boxes_property_get_deferred_change (self, &_tmp2__target);
#line 47 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = _tmp2_;
#line 47 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3__target = _tmp2__target;
#line 47 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ (_tmp3__target);
#line 49 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_property_set_deferred_change (self, NULL, NULL, NULL);
#line 237 "i-properties-provider.c"
}


const gchar* boxes_property_get_description (BoxesProperty* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_description;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 252 "i-properties-provider.c"
}


void boxes_property_set_description (BoxesProperty* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (self->priv->_description);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_description = _tmp1_;
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "description");
#line 271 "i-properties-provider.c"
}


GtkWidget* boxes_property_get_widget (BoxesProperty* self) {
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_widget;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 286 "i-properties-provider.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return self ? g_object_ref (self) : NULL;
#line 293 "i-properties-provider.c"
}


void boxes_property_set_widget (BoxesProperty* self, GtkWidget* value) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_object_unref0 (self->priv->_widget);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_widget = _tmp1_;
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "widget");
#line 312 "i-properties-provider.c"
}


GtkWidget* boxes_property_get_extra_widget (BoxesProperty* self) {
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_extra_widget;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 327 "i-properties-provider.c"
}


void boxes_property_set_extra_widget (BoxesProperty* self, GtkWidget* value) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_object_unref0 (self->priv->_extra_widget);
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_extra_widget = _tmp1_;
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "extra-widget");
#line 346 "i-properties-provider.c"
}


gboolean boxes_property_get_reboot_required (BoxesProperty* self) {
	gboolean result;
	gboolean _tmp0_;
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_reboot_required;
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 361 "i-properties-provider.c"
}


void boxes_property_set_reboot_required (BoxesProperty* self, gboolean value) {
	gboolean _tmp0_;
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_reboot_required = _tmp0_;
#line 8 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "reboot-required");
#line 375 "i-properties-provider.c"
}


guint boxes_property_get_defer_interval (BoxesProperty* self) {
	guint result;
	guint _tmp0_;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_defer_interval;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp0_;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 390 "i-properties-provider.c"
}


void boxes_property_set_defer_interval (BoxesProperty* self, guint value) {
	guint _tmp0_;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = value;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_defer_interval = _tmp0_;
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_notify ((GObject *) self, "defer-interval");
#line 404 "i-properties-provider.c"
}


GSourceFunc boxes_property_get_deferred_change (BoxesProperty* self, gpointer* result_target) {
	GSourceFunc result;
	GSourceFunc _tmp0_;
	void* _tmp0__target;
	GSourceFunc _tmp1_;
	void* _tmp1__target;
#line 17 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->_deferred_change;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0__target = self->priv->_deferred_change_target;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = _tmp0_;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1__target = _tmp0__target;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	*result_target = _tmp1__target;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp1_;
#line 18 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 430 "i-properties-provider.c"
}


static gboolean _boxes_property_deferred_change___lambda11_ (BoxesProperty* self) {
	gboolean result = FALSE;
#line 32 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_property_flush (self);
#line 34 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = FALSE;
#line 34 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 442 "i-properties-provider.c"
}


static gboolean __boxes_property_deferred_change___lambda11__gsource_func (gpointer self) {
	gboolean result;
	result = _boxes_property_deferred_change___lambda11_ (self);
#line 31 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 451 "i-properties-provider.c"
}


void boxes_property_set_deferred_change (BoxesProperty* self, GSourceFunc value, gpointer value_target, GDestroyNotify value_target_destroy_notify) {
	guint _tmp0_;
	GSourceFunc _tmp2_;
	void* _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	GSourceFunc _tmp3_;
	void* _tmp3__target;
	guint _tmp4_;
	guint _tmp5_ = 0U;
#line 21 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_if_fail (self != NULL);
#line 22 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = self->priv->deferred_change_id;
#line 22 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 470 "i-properties-provider.c"
		guint _tmp1_;
#line 23 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp1_ = self->priv->deferred_change_id;
#line 23 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_source_remove (_tmp1_);
#line 24 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		self->priv->deferred_change_id = (guint) 0;
#line 478 "i-properties-provider.c"
	}
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = value;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2__target = value_target;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2__target_destroy_notify = value_target_destroy_notify;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value_target_destroy_notify = NULL;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	(self->priv->_deferred_change_target_destroy_notify == NULL) ? NULL : (self->priv->_deferred_change_target_destroy_notify (self->priv->_deferred_change_target), NULL);
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change = NULL;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target = NULL;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target_destroy_notify = NULL;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change = _tmp2_;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target = _tmp2__target;
#line 27 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target_destroy_notify = _tmp2__target_destroy_notify;
#line 28 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = self->priv->_deferred_change;
#line 28 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3__target = self->priv->_deferred_change_target;
#line 28 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp3_ == NULL) {
#line 29 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
#line 29 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		value = NULL;
#line 29 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		value_target = NULL;
#line 29 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		value_target_destroy_notify = NULL;
#line 29 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 518 "i-properties-provider.c"
	}
#line 31 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = self->priv->_defer_interval;
#line 31 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp5_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, _tmp4_, __boxes_property_deferred_change___lambda11__gsource_func, g_object_ref (self), g_object_unref);
#line 31 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->deferred_change_id = _tmp5_;
#line 21 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
#line 21 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value = NULL;
#line 21 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value_target = NULL;
#line 21 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	value_target_destroy_notify = NULL;
#line 534 "i-properties-provider.c"
}


static void boxes_property_class_init (BoxesPropertyClass * klass) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_property_parent_class = g_type_class_peek_parent (klass);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_type_class_add_private (klass, sizeof (BoxesPropertyPrivate));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_property_get_property;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_boxes_property_set_property;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (klass)->finalize = boxes_property_finalize;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_DESCRIPTION, g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_WIDGET, g_param_spec_object ("widget", "widget", "widget", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_EXTRA_WIDGET, g_param_spec_object ("extra-widget", "extra-widget", "extra-widget", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_REBOOT_REQUIRED, g_param_spec_boolean ("reboot-required", "reboot-required", "reboot-required", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_PROPERTY_DEFER_INTERVAL, g_param_spec_uint ("defer-interval", "defer-interval", "defer-interval", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_signal_new ("refresh_properties", BOXES_TYPE_PROPERTY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 561 "i-properties-provider.c"
}


static void boxes_property_instance_init (BoxesProperty * self) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv = BOXES_PROPERTY_GET_PRIVATE (self);
#line 12 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_defer_interval = (guint) 1;
#line 570 "i-properties-provider.c"
}


static void boxes_property_finalize (GObject* obj) {
	BoxesProperty * self;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_PROPERTY, BoxesProperty);
#line 5 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (self->priv->_description);
#line 6 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_object_unref0 (self->priv->_widget);
#line 7 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_object_unref0 (self->priv->_extra_widget);
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	(self->priv->_deferred_change_target_destroy_notify == NULL) ? NULL : (self->priv->_deferred_change_target_destroy_notify (self->priv->_deferred_change_target), NULL);
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change = NULL;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target = NULL;
#line 15 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self->priv->_deferred_change_target_destroy_notify = NULL;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	G_OBJECT_CLASS (boxes_property_parent_class)->finalize (obj);
#line 594 "i-properties-provider.c"
}


GType boxes_property_get_type (void) {
	static volatile gsize boxes_property_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_property_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesPropertyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_property_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesProperty), 0, (GInstanceInitFunc) boxes_property_instance_init, NULL };
		GType boxes_property_type_id;
		boxes_property_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesProperty", &g_define_type_info, 0);
		g_once_init_leave (&boxes_property_type_id__volatile, boxes_property_type_id);
	}
	return boxes_property_type_id__volatile;
}


static void _vala_boxes_property_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	BoxesProperty * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_PROPERTY, BoxesProperty);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	switch (property_id) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DESCRIPTION:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_string (value, boxes_property_get_description (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_WIDGET:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_object (value, boxes_property_get_widget (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_EXTRA_WIDGET:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_object (value, boxes_property_get_extra_widget (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_REBOOT_REQUIRED:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_boolean (value, boxes_property_get_reboot_required (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DEFER_INTERVAL:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_value_set_uint (value, boxes_property_get_defer_interval (self));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 645 "i-properties-provider.c"
		default:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 651 "i-properties-provider.c"
	}
}


static void _vala_boxes_property_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	BoxesProperty * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_PROPERTY, BoxesProperty);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	switch (property_id) {
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DESCRIPTION:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_description (self, g_value_get_string (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_WIDGET:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_widget (self, g_value_get_object (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_EXTRA_WIDGET:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_extra_widget (self, g_value_get_object (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_REBOOT_REQUIRED:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_reboot_required (self, g_value_get_boolean (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		case BOXES_PROPERTY_DEFER_INTERVAL:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_property_set_defer_interval (self, g_value_get_uint (value));
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 691 "i-properties-provider.c"
		default:
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 4 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		break;
#line 697 "i-properties-provider.c"
	}
}


GType property_creation_flag_get_type (void) {
	static volatile gsize property_creation_flag_type_id__volatile = 0;
	if (g_once_init_enter (&property_creation_flag_type_id__volatile)) {
		static const GFlagsValue values[] = {{PROPERTY_CREATION_FLAG_NONE, "PROPERTY_CREATION_FLAG_NONE", "none"}, {PROPERTY_CREATION_FLAG_NO_USB, "PROPERTY_CREATION_FLAG_NO_USB", "no-usb"}, {0, NULL, NULL}};
		GType property_creation_flag_type_id;
		property_creation_flag_type_id = g_flags_register_static ("PropertyCreationFlag", values);
		g_once_init_leave (&property_creation_flag_type_id__volatile, property_creation_flag_type_id);
	}
	return property_creation_flag_type_id__volatile;
}


GList* boxes_iproperties_provider_get_properties (BoxesIPropertiesProvider* self, BoxesPropertiesPage page, PropertyCreationFlag flags) {
#line 63 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return BOXES_IPROPERTIES_PROVIDER_GET_INTERFACE (self)->get_properties (self, page, flags);
#line 719 "i-properties-provider.c"
}


BoxesProperty* boxes_iproperties_provider_add_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, GtkWidget* widget, GtkWidget* extra_widget) {
	BoxesProperty* result = NULL;
	const gchar* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	BoxesProperty* _tmp3_;
	BoxesProperty* property;
	BoxesProperty* _tmp4_;
#line 65 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = name;
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = widget;
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = extra_widget;
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = boxes_property_new (_tmp0_, _tmp1_, _tmp2_);
#line 66 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	property = _tmp3_;
#line 67 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = _g_object_ref0 (property);
#line 67 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	*list = g_list_append (*list, _tmp4_);
#line 68 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = property;
#line 68 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 751 "i-properties-provider.c"
}


static Block16Data* block16_data_ref (Block16Data* _data16_) {
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return _data16_;
#line 760 "i-properties-provider.c"
}


static void block16_data_unref (void * _userdata_) {
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 769 "i-properties-provider.c"
		BoxesIPropertiesProvider * self;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		self = _data16_->self;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data16_->property);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data16_->entry);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (self);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_slice_free (Block16Data, _data16_);
#line 781 "i-properties-provider.c"
	}
}


static void __lambda18_ (Block16Data* _data16_) {
	BoxesIPropertiesProvider * self;
	GError * _inner_error_ = NULL;
#line 82 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = _data16_->self;
#line 791 "i-properties-provider.c"
	{
		PropertyStringChanged _tmp0_;
		void* _tmp0__target;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ = _data16_->changed;
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0__target = _data16_->changed_target;
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp1_ = boxes_editable_entry_get_text (_data16_->entry);
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp2_ = _tmp1_;
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ (_data16_->property, _tmp2_, _tmp0__target, &_inner_error_);
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		if (_inner_error_ != NULL) {
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			if (g_error_matches (_inner_error_, BOXES_ERROR, BOXES_ERROR_INVALID)) {
#line 811 "i-properties-provider.c"
				goto __catch11_boxes_error_invalid;
			}
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			if (_inner_error_->domain == BOXES_ERROR) {
#line 816 "i-properties-provider.c"
				goto __catch11_boxes_error;
			}
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_clear_error (&_inner_error_);
#line 84 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			return;
#line 825 "i-properties-provider.c"
		}
	}
	goto __finally11;
	__catch11_boxes_error_invalid:
	{
		GError* _error_ = NULL;
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_error_ = _inner_error_;
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_inner_error_ = NULL;
#line 86 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		boxes_editable_entry_start_editing (_data16_->entry);
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_error_free0 (_error_);
#line 840 "i-properties-provider.c"
	}
	goto __finally11;
	__catch11_boxes_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_error_ = _inner_error_;
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_inner_error_ = NULL;
#line 88 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp3_ = _error_;
#line 88 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp4_ = _tmp3_->message;
#line 88 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_warning ("i-properties-provider.vala:88: %s", _tmp4_);
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_error_free0 (_error_);
#line 860 "i-properties-provider.c"
	}
	__finally11:
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_inner_error_ != NULL) {
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_clear_error (&_inner_error_);
#line 83 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 871 "i-properties-provider.c"
	}
}


static void ___lambda18__boxes_editable_entry_editing_done (BoxesEditableEntry* _sender, gpointer self) {
#line 82 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	__lambda18_ (self);
#line 879 "i-properties-provider.c"
}


BoxesProperty* boxes_iproperties_provider_add_string_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, const gchar* value, PropertyStringChanged changed, void* changed_target) {
	BoxesProperty* result = NULL;
	Block16Data* _data16_;
	PropertyStringChanged _tmp0_;
	void* _tmp0__target;
	BoxesEditableEntry* _tmp1_;
	const gchar* _tmp2_;
	PropertyStringChanged _tmp3_;
	void* _tmp3__target;
	const gchar* _tmp4_;
	BoxesProperty* _tmp5_ = NULL;
	BoxesProperty* _tmp6_;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_->_ref_count_ = 1;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_->self = g_object_ref (self);
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = changed;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0__target = changed_target;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_->changed = _tmp0_;
#line 71 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_->changed_target = _tmp0__target;
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = boxes_editable_entry_new ();
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_ref_sink (_tmp1_);
#line 75 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_->entry = _tmp1_;
#line 77 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = value;
#line 77 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_editable_entry_set_text (_data16_->entry, _tmp2_);
#line 78 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_editable_entry_set_selectable (_data16_->entry, TRUE);
#line 79 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = _data16_->changed;
#line 79 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3__target = _data16_->changed_target;
#line 79 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	boxes_editable_entry_set_editable (_data16_->entry, _tmp3_ != NULL);
#line 81 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = name;
#line 81 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp5_ = boxes_iproperties_provider_add_property (self, list, _tmp4_, (GtkWidget*) _data16_->entry, NULL);
#line 81 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_->property = _tmp5_;
#line 82 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_signal_connect_data (_data16_->entry, "editing-done", (GCallback) ___lambda18__boxes_editable_entry_editing_done, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
#line 92 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp6_ = _g_object_ref0 (_data16_->property);
#line 92 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp6_;
#line 92 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	block16_data_unref (_data16_);
#line 92 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data16_ = NULL;
#line 92 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 949 "i-properties-provider.c"
}


static Block17Data* block17_data_ref (Block17Data* _data17_) {
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return _data17_;
#line 958 "i-properties-provider.c"
}


static void block17_data_unref (void * _userdata_) {
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 967 "i-properties-provider.c"
		BoxesIPropertiesProvider * self;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		self = _data17_->self;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data17_->property);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data17_->scale);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (_data17_->label);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_object_unref0 (self);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_slice_free (Block17Data, _data17_);
#line 981 "i-properties-provider.c"
	}
}


static void __lambda19_ (Block17Data* _data17_) {
	BoxesIPropertiesProvider * self;
	GtkScale* _tmp0_;
	gdouble _tmp1_ = 0.0;
	guint64 v;
	GtkLabel* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GtkScale* _tmp5_;
#line 112 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = _data17_->self;
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = _data17_->scale;
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = gtk_range_get_value ((GtkRange*) _tmp0_);
#line 113 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	v = (guint64) _tmp1_;
#line 114 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = _data17_->label;
#line 114 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = g_format_size_full (v * OSINFO_KIBIBYTES, G_FORMAT_SIZE_IEC_UNITS);
#line 114 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = _tmp3_;
#line 114 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_label_set_text (_tmp2_, _tmp4_);
#line 114 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (_tmp4_);
#line 115 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp5_ = _data17_->scale;
#line 115 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_range_set_fill_level ((GtkRange*) _tmp5_, (gdouble) v);
#line 1017 "i-properties-provider.c"
}


static void ___lambda19__gtk_range_value_changed (GtkRange* _sender, gpointer self) {
#line 112 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	__lambda19_ (self);
#line 1024 "i-properties-provider.c"
}


static void ___lambda20_ (Block17Data* _data17_) {
	BoxesIPropertiesProvider * self;
	GError * _inner_error_ = NULL;
#line 128 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	self = _data17_->self;
#line 1033 "i-properties-provider.c"
	{
		PropertySizeChanged _tmp0_;
		void* _tmp0__target;
		BoxesProperty* _tmp1_;
		GtkScale* _tmp2_;
		gdouble _tmp3_ = 0.0;
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ = _data17_->changed;
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0__target = _data17_->changed_target;
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp1_ = _data17_->property;
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp2_ = _data17_->scale;
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp3_ = gtk_range_get_value ((GtkRange*) _tmp2_);
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp0_ (_tmp1_, (guint64) _tmp3_, _tmp0__target, &_inner_error_);
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		if (_inner_error_ != NULL) {
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			if (_inner_error_->domain == BOXES_ERROR) {
#line 1056 "i-properties-provider.c"
				goto __catch12_boxes_error;
			}
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			g_clear_error (&_inner_error_);
#line 130 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
			return;
#line 1065 "i-properties-provider.c"
		}
	}
	goto __finally12;
	__catch12_boxes_error:
	{
		GError* _error_ = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 129 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_error_ = _inner_error_;
#line 129 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_inner_error_ = NULL;
#line 132 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp4_ = _error_;
#line 132 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp5_ = _tmp4_->message;
#line 132 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_warning ("i-properties-provider.vala:132: %s", _tmp5_);
#line 129 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_g_error_free0 (_error_);
#line 1086 "i-properties-provider.c"
	}
	__finally12:
#line 129 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_inner_error_ != NULL) {
#line 129 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 129 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_clear_error (&_inner_error_);
#line 129 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		return;
#line 1097 "i-properties-provider.c"
	}
}


static void ____lambda20__gtk_range_value_changed (GtkRange* _sender, gpointer self) {
#line 128 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	___lambda20_ (self);
#line 1105 "i-properties-provider.c"
}


BoxesProperty* boxes_iproperties_provider_add_size_property (BoxesIPropertiesProvider* self, GList** list, const gchar* name, guint64 size, guint64 min, guint64 max, guint64 step, PropertySizeChanged changed, void* changed_target) {
	BoxesProperty* result = NULL;
	Block17Data* _data17_;
	PropertySizeChanged _tmp0_;
	void* _tmp0__target;
	guint64 _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	guint64 _tmp7_;
	guint64 _tmp8_;
	guint64 _tmp9_;
	GtkScale* _tmp10_;
	GtkScale* _tmp11_;
	guint64 _tmp12_;
	guint64 _tmp13_;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	GtkScale* _tmp16_;
	guint64 _tmp17_;
	guint64 _tmp18_;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_;
	GtkScale* _tmp23_;
	GtkScale* _tmp24_;
	GtkScale* _tmp25_;
	GtkScale* _tmp26_;
	guint64 _tmp27_;
	GtkScale* _tmp28_;
	guint64 _tmp29_;
	GtkScale* _tmp30_;
	GtkScale* _tmp31_;
	GtkScale* _tmp32_;
	const gchar* _tmp33_;
	GtkLabel* _tmp34_;
	GtkScale* _tmp35_;
	BoxesProperty* _tmp36_ = NULL;
	PropertySizeChanged _tmp37_;
	void* _tmp37__target;
	BoxesProperty* _tmp39_;
	BoxesProperty* _tmp40_;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_->_ref_count_ = 1;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_->self = g_object_ref (self);
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0_ = changed;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp0__target = changed_target;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_->changed = _tmp0_;
#line 95 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_->changed_target = _tmp0__target;
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp1_ = size;
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp2_ = g_format_size_full (((guint64) _tmp1_) * OSINFO_KIBIBYTES, G_FORMAT_SIZE_IEC_UNITS);
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp3_ = _tmp2_;
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_ref_sink (_tmp4_);
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp5_ = _tmp4_;
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (_tmp3_);
#line 102 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_->label = _tmp5_;
#line 103 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp6_ = _data17_->label;
#line 103 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp7_ = min;
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp8_ = max;
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp9_ = step;
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp10_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) _tmp7_, (gdouble) _tmp8_, (gdouble) _tmp9_);
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_object_ref_sink (_tmp10_);
#line 105 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_->scale = _tmp10_;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp11_ = _data17_->scale;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp12_ = min;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp13_ = min;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp14_ = g_format_size_full (_tmp13_ * OSINFO_KIBIBYTES, G_FORMAT_SIZE_IEC_UNITS);
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp15_ = _tmp14_;
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_scale_add_mark (_tmp11_, (gdouble) _tmp12_, GTK_POS_BOTTOM, _tmp15_);
#line 107 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (_tmp15_);
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp16_ = _data17_->scale;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp17_ = max;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp18_ = max;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp19_ = g_format_size_full (_tmp18_ * OSINFO_KIBIBYTES, G_FORMAT_SIZE_IEC_UNITS);
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp20_ = _tmp19_;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp21_ = g_strdup_printf ("%s (maximum)", _tmp20_);
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp22_ = _tmp21_;
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_scale_add_mark (_tmp16_, (gdouble) _tmp17_, GTK_POS_BOTTOM, _tmp22_);
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (_tmp22_);
#line 109 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_g_free0 (_tmp20_);
#line 112 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp23_ = _data17_->scale;
#line 112 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	g_signal_connect_data ((GtkRange*) _tmp23_, "value-changed", (GCallback) ___lambda19__gtk_range_value_changed, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 118 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp24_ = _data17_->scale;
#line 118 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_range_set_show_fill_level ((GtkRange*) _tmp24_, TRUE);
#line 119 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp25_ = _data17_->scale;
#line 119 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_range_set_restrict_to_fill_level ((GtkRange*) _tmp25_, FALSE);
#line 120 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp26_ = _data17_->scale;
#line 120 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp27_ = size;
#line 120 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_range_set_value ((GtkRange*) _tmp26_, (gdouble) _tmp27_);
#line 121 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp28_ = _data17_->scale;
#line 121 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp29_ = size;
#line 121 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_range_set_fill_level ((GtkRange*) _tmp28_, (gdouble) _tmp29_);
#line 122 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp30_ = _data17_->scale;
#line 122 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_scale_set_draw_value (_tmp30_, FALSE);
#line 123 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp31_ = _data17_->scale;
#line 123 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp31_, TRUE);
#line 124 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp32_ = _data17_->scale;
#line 124 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp32_, 20);
#line 126 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp33_ = name;
#line 126 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp34_ = _data17_->label;
#line 126 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp35_ = _data17_->scale;
#line 126 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp36_ = boxes_iproperties_provider_add_property (self, list, _tmp33_, (GtkWidget*) _tmp34_, (GtkWidget*) _tmp35_);
#line 126 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_->property = _tmp36_;
#line 127 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp37_ = _data17_->changed;
#line 127 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp37__target = _data17_->changed_target;
#line 127 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (_tmp37_ != NULL) {
#line 1288 "i-properties-provider.c"
		GtkScale* _tmp38_;
#line 128 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		_tmp38_ = _data17_->scale;
#line 128 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		g_signal_connect_data ((GtkRange*) _tmp38_, "value-changed", (GCallback) ____lambda20__gtk_range_value_changed, block17_data_ref (_data17_), (GClosureNotify) block17_data_unref, 0);
#line 1294 "i-properties-provider.c"
	}
#line 136 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp39_ = _data17_->property;
#line 136 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_tmp40_ = _g_object_ref0 (_tmp39_);
#line 136 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	result = _tmp40_;
#line 136 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	block17_data_unref (_data17_);
#line 136 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	_data17_ = NULL;
#line 136 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	return result;
#line 1308 "i-properties-provider.c"
}


static void boxes_iproperties_provider_base_init (BoxesIPropertiesProviderIface * iface) {
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	static gboolean initialized = FALSE;
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
	if (!initialized) {
#line 62 "/extra-data/checkout/gnome/gnome-boxes/src/i-properties-provider.vala"
		initialized = TRUE;
#line 1319 "i-properties-provider.c"
	}
}


GType boxes_iproperties_provider_get_type (void) {
	static volatile gsize boxes_iproperties_provider_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_iproperties_provider_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoxesIPropertiesProviderIface), (GBaseInitFunc) boxes_iproperties_provider_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType boxes_iproperties_provider_type_id;
		boxes_iproperties_provider_type_id = g_type_register_static (G_TYPE_INTERFACE, "BoxesIPropertiesProvider", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (boxes_iproperties_provider_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&boxes_iproperties_provider_type_id__volatile, boxes_iproperties_provider_type_id);
	}
	return boxes_iproperties_provider_type_id__volatile;
}



